%title "CUBE V 1.0", before, skip=2, noinfo

%module cube

%{
#include <string>
  using std::string;
#include "Cube.h"
#include "CUBException.h"

using namespace std;
%}

%include "typemaps.i"
%include "typemaps-py.i"

class Cube {

 public:

  Cube(); 
  ~Cube();

  int def_met(string name, string uom, string descr, int parent_id);   
  
  int def_module(string name);
  int def_region(string name, long begln, long endln, string descr, int mod_id);
  int def_csite(int mod_id, int line, int callee_id);
  int def_cnode(int csite_id, int parent_id);
  
  int def_grid(string name);
  int def_mach(string name, int grid_id);
  int def_node(string name, int mach_id);
  int def_proc(string name, int node_id);
  int def_thrd(string name, int proc_id);

  void set_sev(int prop_id, int cnode_id, int thrd_id, double value);
  void add_sev(int prop_id, int cnode_id, int thrd_id, double value);
  void sub_sev(int prop_id, int cnode_id, int thrd_id, double value);

  void write(string path);
};
