%typemap(python, in) long 
{
  if (PyInt_Check($source))
    {
      $target = PyInt_AsLong($source);
    }
  else if (PyLong_Check($source))
    {
      $target = PyLong_AsLong($source);
    }
  else
    {
      PyErr_SetString(PyExc_TypeError, "not an integer");
      return NULL;
    }
}

%typemap(python, in) string* (string str)
{
  $target = &str;	

  if (PyString_Check($source))
    {
      *$target = PyString_AsString($source);
    }
  else
    {
      PyErr_SetString(PyExc_TypeError, "not a string");
      return NULL;
    }
}

%except(python) 
{	
  try 	
    {	
      $function
    }	
  catch(CUBException e) 
    {
      PyErr_SetString(PyExc_SystemExit, const_cast<char*>(e.get_msg().c_str()));   
      return NULL;
    }
}

