/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  Copyright (c) 2003-2004                                                **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include <iostream>

#include "Event_rep.h"

#include "Error.h"
#include "EventBuffer.h"
#include "State.h"

using namespace earl;
using namespace std;

Event_rep::Event_rep(State&        state,
		     EventBuffer*  buffer,
		     Location*     loc, 
		     double        time) :
  buffer(buffer),
  refc(0),
  pos(state.get_pos() + 1),
  loc(loc),
  time(time),
  enterptr(state.top(loc))
{}

bool           
Event_rep::is_type(etype type) const 
{ 
  if ( type == EVENT ) 
    return true; 
  else 
    return false; 
}

long 
Event_rep::add_ref()
{ 
  if ( ++refc == 1 && buffer != NULL ) 
    buffer->insert(this);
  return refc; 
}

long 
Event_rep::rem_ref() 
{ 
  if ( --refc == 0 && buffer != NULL ) 
    buffer->remove(this->get_pos()); 
  return refc; 
}

void 
Event_rep::trans(State& state) 
{
  if (state.get_pos() != pos - 1)
    throw FatalError("Error in Event_rep::trans(SystemState&).");
  state.inc_pos();
  state.dequeue_mpicoll();
  state.dequeue_ompcoll();
}



















