/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 2003-2004                                                **
**  University of Tennessee                                                **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef _CALLSITE_H
#define _CALLSITE_H   

/*
 *----------------------------------------------------------------------------
 *
 * struct Callsite
 *
 *----------------------------------------------------------------------------
 */

#include <iostream>
  using std::ostream;
  using std::endl;

#include <string>
  using std::string;

#include <dpcl.h>

struct Function;
struct Module;

struct Callsite
{
  int        id;
  Module*    mod;
  int        line;
  Function*  caller;
  Function*  callee;
  string     callee_name;
  bool       isuser;
  InstPoint  before;
  InstPoint  after;
};

ostream& operator<<(ostream& out, const Callsite& csite); 

#endif
