/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 2003-2004                                                ** 
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         ** 
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef DLG_PROG_H
#define DLG_PROG_H

#include <stdio.h>

#include "dlg_mod.h"
#include "dlg_func.h"
#include "dlg_csite.h"

struct dlg_prog;

struct dlg_prog*  dlg_prog_create(const char* path);
void              dlg_prog_delete(struct dlg_prog* prog);

const char*       dlg_prog_name(struct dlg_prog* prog);

long              dlg_prog_num_mods(struct dlg_prog* prog);
long              dlg_prog_num_funcs(struct dlg_prog* prog);
long              dlg_prog_num_csites(struct dlg_prog* prog);

struct dlg_mod*   dlg_prog_mod(struct dlg_prog* prog, long i);
struct dlg_func*  dlg_prog_func(struct dlg_prog* prog, long i);
struct dlg_csite* dlg_prog_csite(struct dlg_prog* prog, long i);

void              dlg_prog_fprintf(FILE* stream, struct dlg_prog* prog);

#endif
