/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef _ELG_MPIREG_H
#define _ELG_MPIREG_H

#ifdef __cplusplus
#   define EXTERN extern "C" 
#else
#   define EXTERN extern 
#endif

/* 
 *-----------------------------------------------------------------------------
 *
 *  EPILOG Library (Event Processing, Investigating, and Logging)
 *
 *  - Registration of MPI functions  
 *
 *-----------------------------------------------------------------------------
 */

#define ELG__MPI_ABORT                              0
#define ELG__MPI_ADDRESS                            1
#define ELG__MPI_ALLGATHER                          2
#define ELG__MPI_ALLGATHERV                         3
#define ELG__MPI_ALLREDUCE                          4
#define ELG__MPI_ALLTOALL                           5
#define ELG__MPI_ALLTOALLV                          6
#define ELG__MPI_ATTR_DELETE                        7
#define ELG__MPI_ATTR_GET                           8
#define ELG__MPI_ATTR_PUT                           9  
#define ELG__MPI_BARRIER                           10
#define ELG__MPI_BCAST                             11
#define ELG__MPI_BSEND                             12
#define ELG__MPI_BSEND_INIT                        13
#define ELG__MPI_BUFFER_ATTACH                     14
#define ELG__MPI_BUFFER_DETACH                     15 
#define ELG__MPI_CANCEL                            16
#define ELG__MPI_CART_COORDS                       17
#define ELG__MPI_CART_CREATE                       18
#define ELG__MPI_CART_GET                          19
#define ELG__MPI_CART_MAP                          20
#define ELG__MPI_CART_RANK                         21
#define ELG__MPI_CART_SHIFT                        22 
#define ELG__MPI_CART_SUB                          23
#define ELG__MPI_CARTDIM_GET                       24 
#define ELG__MPI_COMM_COMPARE                      25
#define ELG__MPI_COMM_CREATE                       26
#define ELG__MPI_COMM_DUP                          27
#define ELG__MPI_COMM_FREE                         28
#define ELG__MPI_COMM_GROUP                        29
#define ELG__MPI_COMM_RANK                         30
#define ELG__MPI_COMM_REMOTE_GROUP                 31
#define ELG__MPI_COMM_REMOTE_SIZE                  32
#define ELG__MPI_COMM_SIZE                         33
#define ELG__MPI_COMM_SPLIT                        34
#define ELG__MPI_COMM_TEST_INTER                   35
#define ELG__MPI_DIMS_CREATE                       36 
#define ELG__MPI_ERRHANDLER_CREATE                 37
#define ELG__MPI_ERRHANDLER_FREE                   38
#define ELG__MPI_ERRHANDLER_GET                    39 
#define ELG__MPI_ERRHANDLER_SET                    40
#define ELG__MPI_ERROR_CLASS                       41 
#define ELG__MPI_ERROR_STRING                      42
#define ELG__MPI_FINALIZE                          43
#define ELG__MPI_GATHER                            44
#define ELG__MPI_GATHERV                           45
#define ELG__MPI_GET_COUNT                         46
#define ELG__MPI_GET_ELEMENTS                      47
#define ELG__MPI_GET_PROCESSOR_NAME                48
#define ELG__MPI_GET_VERSION                       49
#define ELG__MPI_GRAPH_CREATE                      50
#define ELG__MPI_GRAPH_GET                         51
#define ELG__MPI_GRAPH_MAP                         52
#define ELG__MPI_GRAPH_NEIGHBORS                   53
#define ELG__MPI_GRAPH_NEIGHBORS_COUNT             54 
#define ELG__MPI_GRAPHDIMS_GET                     55
#define ELG__MPI_GROUP_COMPARE                     56
#define ELG__MPI_GROUP_DIFFERENCE                  57
#define ELG__MPI_GROUP_EXCL                        58 
#define ELG__MPI_GROUP_FREE                        59
#define ELG__MPI_GROUP_INCL                        60
#define ELG__MPI_GROUP_INTERSECTION                61
#define ELG__MPI_GROUP_RANGE_EXCL                  62
#define ELG__MPI_GROUP_RANGE_INCL                  63
#define ELG__MPI_GROUP_RANK                        64 
#define ELG__MPI_GROUP_SIZE                        65    
#define ELG__MPI_GROUP_TRANSLATE_RANKS             66
#define ELG__MPI_GROUP_UNION                       67
#define ELG__MPI_IBSEND                            68
#define ELG__MPI_INIT                              69
#define ELG__MPI_INITIALIZED                       70
#define ELG__MPI_INTERCOMM_CREATE                  71
#define ELG__MPI_INTERCOMM_MERGE                   72
#define ELG__MPI_IPROBE                            73  
#define ELG__MPI_IRECV                             74
#define ELG__MPI_IRSEND                            75
#define ELG__MPI_ISEND                             76
#define ELG__MPI_ISSEND                            77
#define ELG__MPI_KEYVAL_CREATE                     78
#define ELG__MPI_KEYVAL_FREE                       79
#define ELG__MPI_OP_CREATE                         80
#define ELG__MPI_OP_FREE                           81
#define ELG__MPI_PACK                              82
#define ELG__MPI_PACK_SIZE                         83
#define ELG__MPI_PCONTROL                          84 
#define ELG__MPI_PROBE                             85
#define ELG__MPI_RECV                              86
#define ELG__MPI_RECV_INIT                         87
#define ELG__MPI_REDUCE                            88
#define ELG__MPI_REDUCE_SCATTER                    89 
#define ELG__MPI_REQUEST_FREE                      90 
#define ELG__MPI_RSEND                             91
#define ELG__MPI_RSEND_INIT                        92
#define ELG__MPI_SCAN                              93
#define ELG__MPI_SCATTER                           94
#define ELG__MPI_SCATTERV                          95
#define ELG__MPI_SEND                              96
#define ELG__MPI_SEND_INIT                         97
#define ELG__MPI_SENDRECV                          98
#define ELG__MPI_SENDRECV_REPLACE                  99
#define ELG__MPI_SSEND                            100 
#define ELG__MPI_SSEND_INIT                       101
#define ELG__MPI_START                            102
#define ELG__MPI_STARTALL                         103
#define ELG__MPI_TEST                             104
#define ELG__MPI_TEST_CANCELLED                   105
#define ELG__MPI_TESTALL                          106
#define ELG__MPI_TESTANY                          107
#define ELG__MPI_TESTSOME                         108   
#define ELG__MPI_TOPO_TEST                        109                
#define ELG__MPI_TYPE_COMMIT                      110 
#define ELG__MPI_TYPE_CONTIGUOUS                  111
#define ELG__MPI_TYPE_EXTENT                      112
#define ELG__MPI_TYPE_FREE                        113 
#define ELG__MPI_TYPE_HINDEXED                    114
#define ELG__MPI_TYPE_HVECTOR                     115
#define ELG__MPI_TYPE_INDEXED                     116
#define ELG__MPI_TYPE_LB                          117
#define ELG__MPI_TYPE_SIZE                        118
#define ELG__MPI_TYPE_STRUCT                      119
#define ELG__MPI_TYPE_UB                          120
#define ELG__MPI_TYPE_VECTOR                      121 
#define ELG__MPI_UNPACK                           122
#define ELG__MPI_WAIT                             123
#define ELG__MPI_WAITALL                          124   
#define ELG__MPI_WAITANY                          125
#define ELG__MPI_WAITSOME                         126
#define ELG__MPI_WTICK                            127
#define ELG__MPI_WTIME                            128

extern int     elg_mpi_regid[129];

EXTERN void    elg_mpi_register();


#endif









