/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include "elg_ompreg.h"

#include "elg_trc.h"

int elg_omp_regid[20];

void elg_omp_register()
{
  elg_ui4 fid;
  
  /*fid = elg_def_file("libomp.a");*/
  fid = ELG_NO_ID;

  elg_omp_regid[ELG__OMP_DESTROY_LOCK] =
    elg_def_region("omp_destroy_lock", fid, ELG_NO_LNO, ELG_NO_LNO, "OMP", ELG_FUNCTION);          
  elg_omp_regid[ELG__OMP_DESTROY_NEST_LOCK] =
    elg_def_region("omp_destroy_nest_lock", fid, ELG_NO_LNO, ELG_NO_LNO, "OMP", ELG_FUNCTION);
  elg_omp_regid[ELG__OMP_GET_DYNAMIC] =
    elg_def_region("omp_get_dynamic", fid, ELG_NO_LNO, ELG_NO_LNO, "OMP", ELG_FUNCTION);            
  elg_omp_regid[ELG__OMP_GET_MAX_THREADS] =
    elg_def_region("omp_get_max_threads", fid, ELG_NO_LNO, ELG_NO_LNO, "OMP", ELG_FUNCTION);   
  elg_omp_regid[ELG__OMP_GET_NESTED] =
    elg_def_region("omp_get_nested", fid, ELG_NO_LNO, ELG_NO_LNO, "OMP", ELG_FUNCTION);             
  elg_omp_regid[ELG__OMP_GET_NUM_PROCS] =
    elg_def_region("omp_get_num_procs", fid, ELG_NO_LNO, ELG_NO_LNO, "OMP", ELG_FUNCTION);        
  elg_omp_regid[ELG__OMP_GET_NUM_THREADS] =
    elg_def_region("omp_get_num_threads", fid, ELG_NO_LNO, ELG_NO_LNO, "OMP", ELG_FUNCTION);    
  elg_omp_regid[ELG__OMP_GET_THREAD_NUM] =
    elg_def_region("omp_get_thread_num", fid, ELG_NO_LNO, ELG_NO_LNO, "OMP", ELG_FUNCTION);      
  elg_omp_regid[ELG__OMP_IN_PARALLEL] =
    elg_def_region("omp_in_parallel", fid, ELG_NO_LNO, ELG_NO_LNO, "OMP", ELG_FUNCTION);            
  elg_omp_regid[ELG__OMP_INIT_LOCK] =
    elg_def_region("omp_init_lock", fid, ELG_NO_LNO, ELG_NO_LNO, "OMP", ELG_FUNCTION);                
  elg_omp_regid[ELG__OMP_INIT_NEST_LOCK] =
    elg_def_region("omp_init_nest_lock", fid, ELG_NO_LNO, ELG_NO_LNO, "OMP", ELG_FUNCTION);      
  elg_omp_regid[ELG__OMP_SET_DYNAMIC] =
    elg_def_region("omp_set_dynamic", fid, ELG_NO_LNO, ELG_NO_LNO, "OMP", ELG_FUNCTION);            
  elg_omp_regid[ELG__OMP_SET_LOCK] =
    elg_def_region("omp_set_lock", fid, ELG_NO_LNO, ELG_NO_LNO, "OMP", ELG_FUNCTION);                  
  elg_omp_regid[ELG__OMP_SET_NEST_LOCK] =
    elg_def_region("omp_set_nest_lock", fid, ELG_NO_LNO, ELG_NO_LNO, "OMP", ELG_FUNCTION);        
  elg_omp_regid[ELG__OMP_SET_NESTED] =
    elg_def_region("omp_set_nested", fid, ELG_NO_LNO, ELG_NO_LNO, "OMP", ELG_FUNCTION);              
  elg_omp_regid[ELG__OMP_SET_NUM_THREADS] =
    elg_def_region("omp_set_num_threads", fid, ELG_NO_LNO, ELG_NO_LNO, "OMP", ELG_FUNCTION);    
  elg_omp_regid[ELG__OMP_TEST_LOCK] =
    elg_def_region("omp_test_lock", fid, ELG_NO_LNO, ELG_NO_LNO, "OMP", ELG_FUNCTION);                
  elg_omp_regid[ELG__OMP_TEST_NEST_LOCK] =
    elg_def_region("omp_test_nest_lock", fid, ELG_NO_LNO, ELG_NO_LNO, "OMP", ELG_FUNCTION);      
  elg_omp_regid[ELG__OMP_UNSET_LOCK] =
    elg_def_region("omp_unset_lock", fid, ELG_NO_LNO, ELG_NO_LNO, "OMP", ELG_FUNCTION);              
  elg_omp_regid[ELG__OMP_UNSET_NEST_LOCK] =
    elg_def_region("omp_unset_nest_lock", fid, ELG_NO_LNO, ELG_NO_LNO, "OMP", ELG_FUNCTION);    
}


