/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include "elg_defs.h"

extern int pomp_tracing;

struct ElgRegDescr {
  elg_ui4 rid;     /* region id */
  elg_ui4 brid;    /* region id of implicit barrier */
                   /* also: lockid for critical     */
  elg_ui4 sbrid;   /* region id of enclosed structured block */
                   /* also: inner construct for combined constructs */
  elg_ui4 fid;
  elg_ui4 begln;
  elg_ui4 endln;
};

#define GUARDED_ENTER(id) \
  if ( pomp_tracing ) { \
    struct ElgRegDescr* data = (struct ElgRegDescr*)(r->data); \
    elg_enter(data->id); \
  }

#define GUARDED_ENTER_2(ch,id1,id2) \
  if ( pomp_tracing ) { \
    struct ElgRegDescr* data = (struct ElgRegDescr*)(r->data); \
    if ( r->name[0] == ch ) \
      elg_enter(data->id1); \
    else \
      elg_enter(data->id2); \
  }

#define GUARDED_EXIT() \
  if ( pomp_tracing ) { \
    elg_exit(); \
  }

#define GUARDED_COLL_EXIT() \
  if ( pomp_tracing ) { \
    elg_omp_collexit(); \
  }
