/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (C) 1998-2003                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef ELG_POMP2_CTC_H
#define ELG_POMP2_CTC_H

#include "elg_defs.h"

#ifdef __cplusplus
extern "C" {
#endif

/*
 * CTC field descriptor
 */
typedef struct {
  char *attr;  /* current attribute       */
  char *val;   /* current value           */
  char *str;   /* ctc string value        */
  char *curr;  /* current position in ctc */
} ctc_field;

/*
 * Initialize CTC field descriptor
 */
extern int ctc_init(ctc_field* f, char* str);

/*
 * Get next CTC field
 */
extern int ctc_get_next_field(ctc_field* f);

/*
 * Determine CTC Field Type
 */
enum ctc_field_t { CTC_ESCL, CTC_GROUP, CTC_HASCOPYIN, CTC_HASCOPYPRIV,
  CTC_HASFPRIV, CTC_HASLPRIV, CTC_HASNOWAIT, CTC_HASORD, CTC_HASRED,
  CTC_NAME, CTC_RTYPE, CTC_SSCL, CTC_SCHEDULE, CTC_UNKNOWN };

extern char *ctc_field_type_2_str[];

extern enum ctc_field_t ctc_field_type(char *str);

void conv_ctc_region_type(char *str, elg_ui1* rtype, char** rname);

#ifdef __cplusplus
}
#endif

#endif
