/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (c) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#include <stdio.h>
#include <stdlib.h>

int main () {
  FILE *out;

  if ( (out = fopen("config.h", "w")) == NULL ) {
    perror("elg_types.h");
    exit(1);
  }

  if ( sizeof(char) == 1 ) {
    fprintf(out, "typedef unsigned      char elg_ui1;"
            "   /* unsigned integer of size 1 Byte */\n");
  } else {
    fprintf(stderr, "ERROR: cannot find unsigned integer of size 1 Byte\n");
    exit(1);
  }


  if ( sizeof(short) == 4 ) {
    fprintf(out, "typedef unsigned     short elg_ui4;"
            "   /* unsigned integer of size 4 Byte */\n");
  } else if ( sizeof(int) == 4 ) {
    fprintf(out, "typedef unsigned       int elg_ui4;"
            "   /* unsigned integer of size 4 Byte */\n");
  } else if ( sizeof(long) == 4 ) {
    fprintf(out, "typedef unsigned      long elg_ui4;"
            "   /* unsigned integer of size 4 Byte */\n");
  } else {
    fprintf(stderr, "ERROR: cannot find unsigned integer of size 4 Byte\n");
    exit(1);
  }

  if ( sizeof(long) == 8 ) {
    fprintf(out, "typedef unsigned      long elg_ui8;"
            "   /* unsigned integer of size 8 Byte */\n");
  } else if ( sizeof(long long) == 8 ) {
    fprintf(out, "typedef unsigned long long elg_ui8;"
            "   /* unsigned integer of size 8 Byte */\n");
  } else {
    fprintf(stderr, "ERROR: cannot find unsigned integer of size 8 Byte\n");
    exit(1);
  }

  if ( sizeof(float) == 8 ) {
    fprintf(out, "typedef              float elg_d8; "
            "   /* real of size 8 Byte (ieee 754) */\n");
  } else if ( sizeof(double) == 8 ) {
    fprintf(out, "typedef             double elg_d8; "
            "   /* real of size 8 Byte (ieee 754) */\n");
  } else {
    fprintf(stderr, "ERROR: cannot find real of size 8 Byte (ieee 754)\n");
    exit(1);
  }

  fclose(out);
  return 0;
}
