from Tree import *


import copy
import Pattern 

class PatternTree(Tree):

    def __init__(self, trace, analyzer):

        Tree.__init__(self)

        # get patterns from module
        module = Pattern
        for name in dir(module):
            try:
                if issubclass(module.__dict__[name], Pattern.Pattern) and module.__dict__[name].__doc__:
                    p = module.__dict__[name](trace)
                    if p.isenabled():
                        self.addnode(p.__class__.__name__, p, p.parent())
            except Exception:
                continue
            else:
                continue

        # register callbacks
        for key in self.keys():
            self.data(key).register(analyzer)

       
