import copy

class Tree:

    def __init__(self):

        self._tree  = {}
        self._roots = []
        
    def addnode(self, key, data, parent=None):

        if not parent:
            self._roots.append(key)

        # key not formerly known as parent?
        if not key in self._tree.keys():
            self._tree[key]  = { 'children' : [] }

        node = self._tree[key]
        node['parent']   = parent
        node['data']     = data
        
        if parent in self._tree.keys():
            self._tree[parent]['children'].append(key)
        elif not parent == None:
            self._tree[parent]  = { 'children' : [key] }

    def delnode(self, key):

        # remove from parent's list of children
        if not key in self._roots:
            children = self.children(self.parent(key))
            children.remove(key)

        # remove the node's own children
        children = copy.deepcopy(self.children(key))
        for child in children:
            self.delnode(child)

        # if root node remove from root list
        if key in self._roots:
           roots.remove(key) 

        # remove node itself
        del self._tree[key]

    # traversing the tree

    def roots(self):
        return self._roots

    def children(self, key):
        return self._tree[key]['children']
    
    def parent(self, key):
        return self._tree[key]['parent']
        
    def data(self, key):
        return self._tree[key]['data']

    def keys(self):
        return self._tree.keys()

    # get keys in depth-first search order
    def dfkeys(self, key=None):
        keys = []
        if key == None:
            for root in self.roots():
                keys.append(root)
                keys += self.dfkeys(root)
        else:
            for child in self.children(key):
                keys.append(child)
                keys += self.dfkeys(child)
        return keys

    def iskey(self, key):
        return self._tree.keys()

    def size(self):
        return len(self._tree.keys())







