/****************************************************************************
**  KOJAK                                                                  **
**  http://www.fz-juelich.de/zam/kojak/                                    **
*****************************************************************************
**  Copyright (C) 1998-2004                                                **
**  Forschungszentrum Juelich, Zentralinstitut fuer Angewandte Mathematik  **
**                                                                         **
**  Copyright (c) 2003-2004                                                **
**  University of Tennessee, Innovative Computing Laboratory               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

#ifndef EXP_CALLTREE_H
#define EXP_CALLTREE_H

/*
 *----------------------------------------------------------------------------
 *
 * class CallTree
 *
 *---------------------------------------------------------------------------- 
 */

#include <earl.h>
#include <string>

#include "Tree.h"

struct CallPath
{
  earl::Callsite* csite;
  earl::Region*   callee;
};

class CallTree : public Tree<CallPath*>
{
 public:

  CallTree(earl::EventTrace* trace);
  ~CallTree();

  const earl::Callsite*  get_csite(long cnode_id)  const { return this->get_data(cnode_id)->csite; }
  const earl::Region*    get_callee(long cnode_id) const { return this->get_data(cnode_id)->callee; }
};

#endif






